#!/usr/bin/perl

# http://glob.com.au/windowsupdate_cache
# byron jones
# public domain

# fixed bug .. now prints blank line if there's no change
# fixed bug .. removed psf from extension list
# fixed weirdness .. "next" on some flavours of perl wasn't "next"ing
# fixed v5 issue by not caching iuident.cab (thanks marvi benedet)

$| = 1;

my $cache_path	= '/usr/local/apache/htdocs/cache/store';
my $cache_url	= 'http://10.0.0.254:8000/cache/store';
my $downloader	= '/usr/local/apache/htdocs/cache/download';

URL: while(<>) {

	# grab url (first word)
	($url) = /^(\S+)/;
	$orig_req = $_;
	$orig_url = $url;

	# decode
	$url =~ tr|+| |;
	$url =~ s|%([a-fA-F0-9][a-fA-F0-9])|pack("C", hex($1))|ge;
	$url =~ s/\000+$//;	# trailing nulls

	# check cache store

	{
		my $url = $orig_url;
		$url =~ s#^http://##i;
		$url =~ s/^www\.//i;
		if($url !~ /iuident\.cab/ && -e "$cache_path/$url" && !-d "$cache_path/$url" && !-e "$cache_path/$url.downloading") {
			open(FH, ">>$cache_path/../log");
			print FH '[', scalar localtime, '] ';
			print FH "cachehit ", -s "$cache_path/$url", " $url\n";
			close FH;
			# s|^\S+|$cache_url/$url|;
			print "$cache_url/$url\n";
			next URL;
		}
	}

	# cache windows update and other bits

	if(!/^\Q$cache_url/i) {
		if(
            (
                # any microsoft cab (windowsupdate, officeupdate, msdn, etc)
                   m#^http://(.*?\.microsoft\.com\S+\.(cab|exe))\b#i
                || m#^http://(.*?\.windowsupdate\.com\S+\.(cab|exe))\b#i
                            || m#^http://(.*?mssjus\.www\.conxion\.com\S+\.(cab|exe))\b#i
                # quicktime
                || m#^http://(.*?qtinstall\.apple\.com\S+\.(cab|exe|idx|dat))\b#i
                # java
                || m#^http://(.*?java\.sun\.com\S+\.(cab|exe))\b#i
                # adobe acrobat
                || m#^http://(.*?ardownload\.adobe\.com\S+\.(bin|dmg|idx|gz|exe))\b#i
            )
                && !(m#iuident\.cab\b#i)
		) {
			my $url = $1;
			$url =~ s/^www\.//i;
			if(-e "$cache_path/$url" && !-e "$cache_path/$url.downloading") {
				open(FH, ">>$cache_path/../log");
				print FH '[', scalar localtime, '] ';
				print FH "cachehit ", -s "$cache_path/$url", " $url\n";
				close FH;
				# s|^\S+|$cache_url/$url|;
				print "$cache_url/$url\n";
				next URL;
			} else {
				system("$downloader $url 2>&1 >/dev/null &");
			}
		}
	}

	# no change
	print "\n";

}

__END__
1000355322.691 106912 JIMMY.internal TCP_MISS/200 14884044 GET http://www.download.windowsupdate.com/msdownload/update/v3-19990518/CabPool/Q299444i_7971F868711DB2C9003A57661562968D5BF46A97.exe? - DIRECT/203.102.129.100 application/octet-stream
